        org  64000

UDG:    equ  23675
COORDS: equ  23677
COORDx: equ  23677
COORDy: equ  23678

mcvars: defb 00       ;(ix+0) 64000
maxx:   defb 00       ;(ix+1);rightmost x coordinate limit
mx:     defb 00       ;(ix+2);pixrow scan width (4-8)
my:     defb 00       ;(ix+3);pixcol scan depth (4-8)
bitvald:defb 00       ;(ix+4);current d$ bitval to set (128=7,64=6,32=5,16=4,...)
shifts: defb 00       ;(ix+5); x-x0-b+1   number of shifts required
tc:     defb 00       ;(ix+6);number of character defs in t$()
pixpos: defb 00       ;(ix+7);pixel position 8->1
myt:    defb 00       ;(ix+8);pixcol scan depth (4-8) - text
myg:    defb 00       ;(ix+9);pixcol scan depth (4-8) - graphic
bitvalx:defb 00     ;(ix+$0A); 2^(8-mx) max d$ bitval to set (16=4,8=3,4=2,2=1,1=0)

        defw plotter,decode,findvariable,chkbit,chkchar,toprow
        defw getminx,getmaxx,shift,markduplicates,copychar,updatewarray
        defw endofcode

plotter:ld   de,(UDG)        ;DE=location of d$()
        push de
        ld   bc,(COORDS)
        call $22aa           ;PIXEL_ADD
        sub  8
        neg
        ld   (pixpos),a      ;save pixel position 8->1
        exx
        ld   a,(my)
        ld   b,a             ;B'=my
        pop  de
        ld   a,(de)
        exx
N0:     push hl
        ld   d,a             ;D=ABCDEFGH
        ld   e,0
        ld   B,$ff           ;B=%11111111
        ld   a,(pixpos)
N1:     sla  b
        sla  d
        rl   e
        dec  a
        jr   nz,N1
N2:     ld   a,(hl)          ;A=abcdefgh B=%11100000, E=000ABCDE, D=FGH00000
        or   e               ;A=abcABCDE
        ld   (hl),a
        inc  hl
        ld   a,l
        and  $1f
        jr   z,N9            ;skip 2nd byte if on next line
        ld   a,(hl)
        or   d               ;A=FGHlmnop
        ld   (hl),a
N9:     exx
        dec  b
        inc  de
        ld   a,(de)
        exx
        pop  hl
        ret  z
        ex   af,af'
        inc  h               ;calculate address of next pixrow down
        ld   a,h
        and  $07
        call z,hlnext        ;into next 2k segment
        ex   af,af'
        jr   N0


tctmyt: defs 2               ;tct*myt
yrow1:  equ  23670           ;location of variable (in SEED)

decode: ld   ix,mcvars
        ld   a,(tc)          ;A =tct
        call $2d28           ;STACK_A
        ld   a,(myt)         ;A =myt
        call $2d28           ;STACK_A
        rst  $28
        defb $04             ;multiply tct*myt
        defb $38             ;end_calc
        call $2da2           ;FP_TO_BC
        ld   (tctmyt),bc
        ld   a,"y"
        call findsarray      ;find y$() (character set)
        dec  hl
        dec  hl
        push hl
        ld   a,"z"
        call findsarray      ;find z$() (print control string)
        push hl
        dec  hl
        dec  hl
        dec  hl
        ld   b,(hl)
        dec  hl
        ld   c,(hl)          ;BC=rows in z$()
        pop  hl
        pop  de
        ld   (yrow1),de

nxtchr: push bc
        ld   a,(hl)
        cp   $ff
        jr   nz,nxtxco
        inc  hl
        ld   a,(hl)
        ld   (COORDy),a      ;COORDS:y
        jr   nxtchk

nxtxco: ld   (COORDx),a      ;COORDS:x
        inc  hl
        ld   e,(ix+8)        ;E = 64008 = myt
        ld   bc,0
        ld   d,(hl)          ;D =d = character code (text)
        ld   a,d
        dec  a
        cp   (ix+6)          ;  = 64006 = tct
        jr   c,getchar

        ld   e,(ix+9)        ;E = 64009 = myg
        ld   bc,(tctmyt)
        ld   a,d
        sub  (ix+6)          ;A =d - tct
        ld   d,a             ;D =d - tct = character code (graphic)

getchar:push hl
        ld   h,b
        ld   l,c             ;HL=char.set base offset (0 or tct*myt)
        ld   bc,(yrow1)
        add  hl,bc           ;HL=y$ base row address for charset

        dec  d               ;D =d-1
        ld   b,d             ;B =char.def. row offset from charset base
        ld   (ix+3),e        ;  = 64003 = char.def. length
        ld   d,0
        jr   z,plotit        ;if offset=0

addoff: add  hl,de
        djnz addoff          ;HL=y$ row offset for chardef
plotit: call plotter+3
        pop  hl

nxtchk: pop  bc
        dec  bc
        inc  hl
        ld   a,b
        or   c
        jr   nz,nxtchr
        ret


findsarray:                  ;A =array letter, set by calling routine
        ld   b,6             ;B =type 6 =string array
        call findvariable
        ld   bc,8            ;assume 2D array (8 byte header)
        add  hl,bc
        ret

find_x: ld   a,"x"
        ld   b,7             ;B =type 7 =FOR...NEXT control
        call findshortnumber ;find x FOR...NEXT control variable
        ld   (COORDx),a      ;POKE 23677,x
        ret

findshortnumber:
        call findvariable
        inc  hl
        inc  hl
        inc  hl
        ld   a,(hl)
        ret

findlongnumber:              ;when type=5, HL points to name, C=length
        ld   b,0
        push bc
        ld   de,vname
        ld   a,(hl)
        ldir
        dec  de
        ex   de,hl
        set  7,(hl)          ;set end of name marker bit
        ex   de,hl
        ld   b,5
        call findvariable
        pop  bc

        inc  c
        inc  c
        add  hl,bc           ;HL=smallint lo-byte address
        ld   c,(hl)
        inc  hl
        ld   b,(hl)
        ret

;types: 2=string, 3=number (short name), 4=number array, 5=number (long name)
;       6=string array, 7=FOR...NEXT control
;header byte = type*32+CODE "letter"-96
vname:  defs 16              ;encoded variable name

findvariable:                ;A =letter; B=type;
        rrc  b
        rrc  b
        rrc  b               ;B =type*32
        sub  96              ;A =CODE "letter"-96
        add  a,b
        ld   (vname),a
        ld   c,a             ;C =header byte
        ld   hl,(23627)      ;HL=(VARS)
nextvar:ld   a,(hl)
        cp   c
        jr   nz,nextvariable
        ld   a,b             ;A =variable's type code * 32
        cp   5*32
        jr   nz,found
nextvariable:
        cp   $80
        jp   z,$0670         ;REPORT_2 - Variable not found
                             ;not found (reached $80 end marker)
        and  %11100000
        bit  5,a
        jr   nz,number
        inc  hl              ;string or array
        ld   e,(hl)
        inc  hl
        ld   d,(hl)
skip2:  inc  hl
        add  hl,de
        jr   nextvar
number: cp   3*32
        jr   z,number1
        cp   7*32
        jr   z,fornext
        push bc
        ld   de,vname
        ld   bc,0
        push hl
nextlet:inc  hl              ;number with long name
        inc  de
        inc  b
        ld   a,(de)
        cp   (hl)
        jr   nz,nomatch
        inc  c
nomatch:bit  7,(hl)
        jr   z,nextlet
        ld   a,b
        sub  c
        pop  de              ;DE=start of name, HL=end of name
        pop  bc
        jr   nz,number1
        ex   de,hl           ;HL=start of name (ie. variable's address)
        ld   a,b
        cp   5*32
        jr   z,found
        ex   de,hl           ;HL=end of name
number1:ld   de,5            ;number with short name
        jr   skip2
fornext:ld   de,18           ;for-next number
        jr   skip2

found:  ld   b,h
        ld   c,l
done:   ret


bitpos: defb 128,64,32,16,8,4,2,1

; scan up to pixcol key mx of my depth
; pixcol key =2^b where b=bitpos 7->0
chkbit:
        call find_x
        ld   ix,mcvars
        ld   (ix+4),128
        ld   b,8             ;B =length d$
        ld   hl,(UDG)        ;HL=location of d$()
resetd: ld   (hl),0          ;reset d$()
        inc  hl
        djnz resetd
        ld   a,9
        sub  (ix+2)          ;A =9-mx
        ld   b,a
        xor  a
        scf
setmx:  rla
        djnz setmx
        ld   (bitvalx),a     ;  =2^(8-mx)
        ld   bc,(COORDS)
        call $22aa           ;PIXEL_ADD
        ld   c,0             ;C =set pixcol counter
        exx
        ex   de,hl
        ld   hl,bitpos
        ld   b,0
        ld   c,a             ;C'=bit position 0->7
        add  hl,bc
        ld   a,(hl)          ;A =bit value to check
        ex   de,hl
        exx

next_x: ld   b,(ix+3)        ;B =my
        ex   af,af'
        xor  a               ;A'=pt =set pixel counter
        ex   af,af'
        ld   de,(UDG)
        push hl              ;HL=pixel address

for_d:  push af           ;11;A =bit value to check
        and  (hl)         ; 7;check selected bit in display
        jr   z,next_d     ;12
                          ;** = 30
bitset: ld   a,(bitvald)  ;13 A =cur d$ bitval to set (128=7,64=6,32=5,16=4,...)
        ex   de,hl        ; 4
        or   (hl)         ; 7
        ld   (hl),a       ; 7 set selected bit in d$()
        ex   de,hl        ; 4
        ex   af,af'       ; 4
        inc  a            ; 4 A'=pt =set pixel counter
        ex   af,af'       ; 4
                          ;** = 47
next_d: inc  de           ; 6 DE=byte position in d$()
        inc  h            ; 4 calculate address of next pixrow down
        ld   a,h          ; 4
        and  $07          ; 7
        call z,hlnext     ;10/17 into next 2k segment
        pop  af           ;10 A = bit value to check
        dec  b            ; 4 = pixcol scan depth remaining
        jr   nz,for_d     ;12
                          ;** = 57/64
        pop  hl              ;HL=pixel address
        ex   af,af'
        inc  c               ;C =set pixcol counter
        or   a               ;A'=pt = set pixels in pixcol
        ld   b,a
        ld   a,(bitvald)     ;cur d$ bitval to set (128=7,64=6,32=5,16=4,...)
        jr   nz,checkmx      ;non-zero pixcol
        dec  c
        cp   128
        jr   nz,decend       ;zero pixcol, prior non-zero pixcols

checkmx:cp   (ix+$0A)        ;bitvalx = max d$ bitval to set (16=4,8=3,4=2,2=1,1=0)
        jr   z,chkend
        ld   a,(COORDx)      ;A'= 23677 = current x coordinate
        cp   (ix+1)          ;maxx = rightmost x coordinate limit
        jr   nc,chkend
        inc  a
        ld   (COORDx),a      ;  = 23677 = current x coordinate

        xor  a
        cp   b
        jr   z,nobit         ;B =pt = set pixels in pixcol
        srl  (ix+4)          ;bitvald = cur d$ bitval to set (128=7,64=6,32=5,16=4,...)

nobit:  ex   af,af'
        srl  a               ;A =bit value to check
        jr   nz,next_x
        rra                  ;A =128
        inc  hl              ;move into next byte in pixrow
        jr   next_x

decend: ld   a,(COORDx)      ;  = 23677 = current x coordinate
        dec  a
        ld   (COORDx),a
chkend: ex   af,af'
        ld   b,0             ;BC=set pixcol counter
        ret


hldown: inc  h               ;calculate address of next pixrow down
        ld   a,h
        and  $07
        ret  nz
hlnext: ld   a,l             ;into next 2k segment
        sub  $e0
        ld   l,a
        sbc  a,a
        and  $f8
        add  a,h
        ld   h,a
        ret


; look for a match on d$() in t$()
chkchar:ld   a,"t"
        call findsarray      ;find t$() (character set)
        ld   de,(UDG)        ;find d$() (character def)
        ld   ix,mcvars
        ld   b,(ix+6)        ;tc = number of character defs in t$()
        ld   c,(ix+3)        ;my = pixcol scan depth
        push bc

chkloop:push hl
        push de
        ld   b,c
chkbyte:ld   a,(de)
        cp   (hl)
        jr   nz,nxtbyte
        inc  de
        inc  hl
        djnz chkbyte
nxtbyte:pop  de
        pop  hl
        xor  a
        cp   b
        pop  bc
        jr   z,chkdone
        dec  b               ;number of character defs to check in t$()
        jr   z,chkdone
        push bc
        ld   b,0
        add  hl,bc
        jr   chkloop

chkdone:ld   c,b
        ld   b,0
        xor  a
        cp   c
        ret  z
        ld   a,(tc)          ;tc-C+1 = matched def pointer
        sub  c
        inc  a
        ld   c,a
        ret


; find next down non-zero pixrow
toprow: ld   bc,(COORDS)
        ld   c,0             ;x
        call $22aa           ;PIXEL_ADD
        ld   a,(COORDy)      ;y
        ld   b,a

prnext: ld   d,h             ;pixrow loop
        ld   e,l
        xor  a
        ld   c,32
pcnext: or   (hl)            ;print column loop
        jr   nz,topend
        inc  hl
        dec  c
        jr   nz,pcnext
        ld   h,d
        ld   l,e
        inc  h               ;calculate address of next pixrow down
        ld   a,h
        and  $07
        call z,hlnext        ;into next 2k segment
        djnz prnext

topend: ld   a,b
        ld   (COORDy),a      ;COORDS:y
        ld   b,0
        ld   c,a
        ret


; find leftmost non-zero byte on this pixrow
; starts with 23677=minx, 23678=y
getminx:call leftadd
        xor  a               ;A =minx coordinate, 0,8,16,...etc
nextmin:ex   af,af'
        xor  a
        or   (hl)            ;check byte at current x,y
        jr   nz,doneadd      ;if non-zero then finish
        ex   af,af'
        inc  hl
        cp   d               ;compare x-coord to last minx set value
        jr   z,doneadd+1     ;if reached then finish
        add  a,8
        jr   nextmin

; find rightmost non-zero byte on this pixrow
; starts with 23677=maxx, 23678=y
getmaxx:call rightadd
        ld   a,255           ;A =maxx coordinate, 255,247,239,...etc
nextmax:ex   af,af'
        xor  a
        or   (hl)            ;check byte at current x,y
        jr   nz,doneadd      ;if non-zero then finish
        ex   af,af'
        dec  hl
        cp   d               ;compare x-coord to last maxx set value
        jr   z,doneadd+1     ;if reached then finish
        sub  8
        jr   nextmax


; get display address of a right-hand column
rightadd:
        ld   c,255           ;BC=y,255
        jr   bothadd
; get display address of a left-hand column
leftadd:
        ld   c,0             ;BC=y,0
bothadd:ld   a,(COORDy)
        ld   b,a             ;B =y
        call $22aa           ;PIXEL_ADD
        ld   a,(COORDx)
        ld   d,a             ;D =minx or maxx
        ret
doneadd:ex   af,af'
        ld   b,0
        ld   c,a             ;return BC with new maxx>=oldmaxx
        ret                  ;            or new minx<=oldminx


; shift right chardef for correct alignment when fixed size chosen
shift:  ld   hl,(UDG)        ;find d$() (character def)
        ld   bc,0000
        ld   a,(shifts)
        and  %00000111
        or   a
        ret  z
        ld   c,a             ;C =number of shifts required
        ld   a,(my)
        ld   e,a             ;E =number of bytes to shift
shift0: ld   b,c
        ld   a,(hl)
shift1: srl  a
        djnz shift1
        ld   (hl),a
        inc  hl
        dec  e
        jr   nz,shift0
        ld   a,(shifts)
        and  %11111000
        ld   c,a
        ret


;1 REMH-------.L-------
;010ssrrr.lllqqqqq
;s=segment,r=pixrow,l=line,q=col
;B         C         D      E
;5 PAUSE0:DIMc(20):LETcc=1:REMrow1=zerochecksum
;10 FORs=0TO16STEP8
;15 FORl=0TO224STEP32:LETl32=l/32
;20 FORq=0TO31:LETts=0:LETdigit=1
;30 FORr=0TO7
;40 LEThl=(64+s+r)*256+l+q
;45 LETts=ts+PEEKhl*digit:LETdigit=digit+1
;50 NEXTr
;60 FORa=1TOcc:IFc(a)=tsTHENPRINTATl32,q;"":GOTO70
;61 NEXTa:LETcc=cc+1:LETc(cc)=ts
;70 NEXTq:NEXTl:NEXTs

markduplicates:
        ld   a,2
        call $1601           ;CHAN-OPEN open channel A
        ld   ix,variables    ;5 PAUSE0:DIMc(20):LETcc=1:
        ld   hl,carray
        xor  a
        ld   (hl),a
        inc  hl
        ld   (hl),a          ;clear c(1)
        ld   (ix+0),1
        ld   b,a
        ld   c,a
        ld   d,a
        ld   e,a
        exx
        ld   c,0             ;C'=segment# 0,1,2
        ld   (hl_alt),hl     ;save HL'
        exx

for_s:                       ;10 FORs=0TO16STEP8
for_l:  ld   a,d             ;15 FORl=0TO224STEP32:LETl32=l/32
        rlca
        rlca
        rlca
        add  a,b
        ld   (l32),a
for_q:                       ;20 FORq=0TO31:LETts=0:LETdigit=1
        ld   (ix+2),0        ; =ts.lo
        ld   (ix+3),0        ; =ts.hi
        ld   (ix+4),1        ; =digit
        ld   (ix+7),e        ; =qcol
for_r:                       ;30 FORr=0TO7
        ld   a,64            ;40 LEThl=(64+s+r)*256+l+q
        or   b
        or   c
        ld   h,a
        ld   a,d
        or   e
        ld   l,a
        ld   a,(hl)          ;45 LETts=ts+PEEKhl*digit:LETdigit=digit+1
        exx
        ld   hl,(ts)
        ld   d,0
        ld   e,a
        ld   b,(ix+4)
hldigit:add  hl,de
        djnz hldigit
        ld   (ts),hl
        inc  (ix+4)
        exx
        inc  c               ;50 NEXTr
        ld   a,7
        cp   c
        jr   nc,for_r
        ld   c,0

        push hl
        exx                  ;60 FORa=1TOcc:IFc(a)=tsTHENPRINTATl32,q;"":GOTO70
        ld   b,(ix+0)
        ld   de,(ts)
        ld   hl,carray
for_a:  ld   a,(hl)
        inc  hl
        cp   e
        jr   nz,next_a
        ld   a,(hl)
        cp   d
        jr   nz,next_a
        ld   a,(ix+0)
        sub  b               ;matched
        jr   next_q
next_a: inc  hl              ;61 NEXTa:LETcc=cc+1:LETc(cc)=ts
        djnz for_a
        inc  (ix+0)          ;not matched
        ld   (hl),e
        inc  hl
        ld   (hl),d
        xor  a

next_q: ex   af,af'
        ld   a,$58           ;HL=attribute base address hi-byte
        add  a,c             ;C'=segment#
        pop  hl              ;L'=line*32 + column
        ld   h,a             ;HL'=attribute address
        ex   af,af'
        ld   (hl),a
        exx                  ;70 NEXTq:NEXTl:NEXTs

        inc  e               ;E =col
        ld   a,31
        cp   e
        jr   nc,for_q
        ld   e,0

        ld   a,d             ;D =line (in segment)
        cp   160
        jr   nz,next_l2
        ld   a,b
        cp   16
        jr   z,line23
        ld   a,d
next_l2:add  a,32
        ld   d,a
        jp   nz,for_l

        exx
        inc  c               ;C'=segment#
        exx
        ld   a,b             ;B =segment# * 8
        add  a,8
        ld   b,a
        cp   24
        jp   c,for_s

line23: exx
        ld   hl,(hl_alt)     ;restore HL'
        exx
        ret

variables:
cc:     defb 00              ;(ix+0)
l32:    defb 00              ;(ix+1)
ts:     defw 0000            ;(ix+2)
digit:  defb 00              ;(ix+4)
hl_alt: defw 0000
qcol:   defb 00              ;(ix+7)


;copy current on-screen char to d$() if a duplicate
copychar:
        call find_x
        ld   bc,(COORDS)
        call $22aa           ;PIXEL_ADD
        call df_att
        ld   b,0
        ld   a,(de)
        ld   c,a
        or   a               ;black PAPER, black INK
        ret  z               ;return if first occurrence
        ld   de,(UDG)        ;DE=location of d$()
        ld   b,8
copybyte:
        ld   a,(hl)
        ld   (de),a
        inc  h
        inc  de
        djnz copybyte
        ret


; get attribute address for display file address
df_att: ld   a,h
        rrca
        rrca
        rrca
        and  $03
        or   $58
        ld   d,a
        ld   e,l
        ret


; increment w$() pointer tt and update w$()
; LET tt=tt+1: LET w$(tt)=CHR$ d+CHR$ x0+CHR$ y
tt:     defm "tt"
x0:     defm "x0"
;types: 2=string, 3=number (short name), 4=number array, 5=number (long name)
;       6=string array, 7=FOR...NEXT control
updatewarray:
        ld   hl,tt
        ld   c,2
        call findlongnumber  ;BC=tt
        inc  bc              ; LET tt=tt+1
        ld   (hl),b
        dec  hl
        ld   (hl),c
        push bc

        ld   a,"w"
        call findsarray
        ex   de,hl           ;DE=w$(1)
        pop  bc              ;BC=tt
        push bc
        dec  bc
        ld   h,b
        ld   l,c
        add  hl,bc
        add  hl,bc           ;HL=(tt-1)*3 =w$(tt) row offset
        add  hl,de           ;HL=w$(tt) row address

        push hl
        ld   a,"d"
        ld   b,3
        call findshortnumber ;A =d
        pop  hl
        ld   (hl),a
        inc  hl

        push hl
        ld   hl,x0
        ld   c,2
        call findlongnumber  ;BC=x0
        pop  hl
        ld   (hl),c
        inc  hl

        push hl
        ld   a,"y"
        ld   b,7
        call findshortnumber ;A =y
        pop  hl
        ld   (hl),a

        pop  bc              ;BC=tt
        ret


endofcode:
carray: equ  endofcode